using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reactive;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace Prak12.ViewModels
{
	public class ShowTeachersViewModel : ReactiveObject
	{
        public ShowTeachersViewModel()
        {
            AddNewTeacherCommand = ReactiveCommand.Create<string>(AddNewTeacherCommandRun);
            using (AvaloniaPrakt12DbContext DB = new AvaloniaPrakt12DbContext())
            {
                TeachersCollection = new ObservableCollection<Teacher>(DB.Teachers.Include(a => a.IdGenderNavigation)
                    .Include(a => a.TeachersCourses).ThenInclude(a => a.IdCourseNavigation)
                    .Include(a => a.TeachersSubjects).ThenInclude(a => a.IdSubjectNavigation)
                    .ToList());
            }
        }


        public event Action ButtonAddNewTeacherWasPressed;


        public ObservableCollection<Teacher> TeachersCollection
        {
            get => _teachersCollection;
            set => this.RaiseAndSetIfChanged(ref _teachersCollection, value);
        }

        public ReactiveCommand<string, Unit> AddNewTeacherCommand { get; }


        public void AddNewTeacherCommandRun(string param) => ButtonAddNewTeacherWasPressed();


        private ObservableCollection<Teacher> _teachersCollection;
    }
}